import SchemaItem from '../SchemaItem'

export default class SchemaLiteral<Type> extends SchemaItem<Type> {
	public constructor(private readonly value: Type) {
		super([value])

		this.validations.push({ fn: (it) => it === this.value })
	}

	public override isOfType(input: unknown): input is Type {
		return typeof input === typeof this.value
	}
}
